/*
Circuit synthesised by Reed-Muller Calculator  2009, Newcastle University
03/11/11 18:56
Synthesised in 0.09s
*/

/*
The circuit implements following () Reed-Muller expansions:
F0: k=3, a=[1011000110000110]
F1: k=3, a=[0100100110100110]
F2: k=3, a=[0101001100101010]
F3: k=9, a=[1010100001000000]
*/

/*
Physical characteristics (statistically estimated):
Total Switching energy of gates*: 10.349999999999998
Total area of gates: 7908.0
Longest delay: 10.0
Total switching activity of wires*: 28
Total number of operations: 32
Operations by radix: [2:32]
(cost = 28.0)
* - maximum value for non-balanced encodings
*/

module null(F01, F02, F11, F12, x0, x1, x2, x3);
input[1:0] x0; 
input[1:0] x1; 
input[1:0] x2; 
input[1:0] x3; 
output[1:0] F01; 
output[1:0] F02; 
output[1:0] F11; 
output[1:0] F12; 
wire[1:0] wi1x3; GF2ADD1 ii1x3(wi1x3, x3);
wire[1:0] wi1x0; GF2ADD1 ii1x0(wi1x0, x0);
wire[1:0] w_t14; GF2MUL i_t14(w_t14, wi1x0, wi1x3);
wire[1:0] w_s3_0; GF2ADD i_s3_0(w_s3_0, x2, w_t14);
wire[1:0] wi1x1; GF2ADD1 ii1x1(wi1x1, x1);
GF2ADD i_s3_1(F12, wi1x1, w_s3_0);
wire[1:0] w_t1; GF2MUL i_t1(w_t1, wi1x0, wi1x1);
wire[1:0] w_t3; GF2MUL i_t3(w_t3, w_t1, x2);
wire[1:0] w_t7; GF2MUL i_t7(w_t7, wi1x1, x2);
wire[1:0] w_s2_1; GF2ADD i_s2_1(w_s2_1, w_t7, w_t3);
wire[1:0] w_s2_0; GF2ADD i_s2_0(w_s2_0, wi1x0, w_t1);
wire[1:0] w_s2_2; GF2ADD i_s2_2(w_s2_2, w_s2_0, w_s2_1);
wire[1:0] w_t11; GF2MUL i_t11(w_t11, x2, x3);
wire[1:0] w_t10; GF2MUL i_t10(w_t10, wi1x1, x3);
wire[1:0] w_s2_3; GF2ADD i_s2_3(w_s2_3, w_t10, w_t11);
wire[1:0] w_t8; GF2MUL i_t8(w_t8, x3, w_t7);
wire[1:0] w_s2_4; GF2ADD i_s2_4(w_s2_4, w_t8, w_s2_3);
GF2ADD i_s2_5(F11, w_s2_4, w_s2_2);
wire[1:0] w_s1_1; GF2ADD i_s1_1(w_s1_1, w_t3, x3);
wire[1:0] w_s1_0; GF2ADD i_s1_0(w_s1_0, wi1x0, x2);
wire[1:0] w_s1_2; GF2ADD i_s1_2(w_s1_2, w_s1_0, w_s1_1);
wire[1:0] w_t5; GF2MUL i_t5(w_t5, wi1x0, x2);
wire[1:0] w_t6; GF2MUL i_t6(w_t6, x3, w_t5);
wire[1:0] w_s1_3; GF2ADD i_s1_3(w_s1_3, w_t10, w_t6);
wire[1:0] w_s1_4; GF2ADD i_s1_4(w_s1_4, w_t8, w_s1_3);
GF2ADD i_s1_5(F02, w_s1_4, w_s1_2);
wire[1:0] w_s0_0; GF2ADD i_s0_0(w_s0_0, w_t1, w_t3);
wire[1:0] wi1i1x1; GF2ADD1 ii1i1x1(wi1i1x1, wi1x1);
wire[1:0] w_s0_1; GF2ADD i_s0_1(w_s0_1, wi1i1x1, w_s0_0);
wire[1:0] w_s0_2; GF2ADD i_s0_2(w_s0_2, x3, w_t6);
wire[1:0] w_s0_3; GF2ADD i_s0_3(w_s0_3, w_t8, w_s0_2);
GF2ADD i_s0_4(F01, w_s0_3, w_s0_1);
endmodule

