/*
Circuit synthesised by Reed-Muller Calculator  2009, Newcastle University
03/11/11 18:57
Synthesised in 0.099s
*/

/*
The circuit implements following () Reed-Muller expansions:
F0: k=3, a=[1A11AB0A0B0101A0]
F1: k=3, a=[0A01B01B0AAA1110]
*/

/*
Physical characteristics (statistically estimated):
Total Switching energy of gates*: 11.8
Total area of gates: 26778.0
Longest delay: 12.0
Total switching activity of wires*: 29
Total number of operations: 44
Operations by radix: [2:2; 4:42]
(cost = 29.0)
* - maximum value for non-balanced encodings
*/

module null(F0, F1, x0, x1);
input[3:0] x0; 
input[3:0] x1; 
output[3:0] F0; 
output[3:0] F1; 
wire[3:0] wiBx0; GF4ADDB iiBx0(wiBx0, x0);
wire[1:0] w_3iBx0; GF4PWR3 i_3iBx0(w_3iBx0, wiBx0);
wire[3:0] w_2x1; GF4PWR2 i_2x1(w_2x1, x1);
wire[3:0] w_t7; GF24MUL i_t7(w_t7, w_2x1, w_3iBx0);
wire[3:0] wtA_t7; GF4MULA itA_t7(wtA_t7, w_t7);
wire[3:0] w_2iBx0; GF4PWR2 i_2iBx0(w_2iBx0, wiBx0);
wire[3:0] w_t11; GF4MUL i_t11(w_t11, w_2iBx0, w_2x1);
wire[3:0] wtA_t11; GF4MULA itA_t11(wtA_t11, w_t11);
wire[3:0] w_s1_4; GF4ADD i_s1_4(w_s1_4, wtA_t11, wtA_t7);
wire[3:0] w_t6; GF4MUL i_t6(w_t6, wiBx0, w_2x1);
wire[3:0] wtA_t6; GF4MULA itA_t6(wtA_t6, w_t6);
wire[3:0] w_t5; GF24MUL i_t5(w_t5, x1, w_3iBx0);
wire[3:0] wtB_t5; GF4MULB itB_t5(wtB_t5, w_t5);
wire[3:0] w_s1_3; GF4ADD i_s1_3(w_s1_3, wtB_t5, wtA_t6);
wire[3:0] w_s1_5; GF4ADD i_s1_5(w_s1_5, w_s1_3, w_s1_4);
wire[3:0] w_t10; GF4MUL i_t10(w_t10, w_2iBx0, x1);
wire[3:0] wtBx1; GF4MULB itBx1(wtBx1, x1);
wire[3:0] w_s1_1; GF4ADD i_s1_1(w_s1_1, wtBx1, w_t10);
wire[3:0] wtAiBx0; GF4MULA itAiBx0(wtAiBx0, wiBx0);
wire[3:0] w_s1_0; GF24ADD i_s1_0(w_s1_0, wtAiBx0, w_3iBx0);
wire[3:0] w_s1_2; GF4ADD i_s1_2(w_s1_2, w_s1_0, w_s1_1);
wire[3:0] w_s1_6; GF4ADD i_s1_6(w_s1_6, w_s1_2, w_s1_5);
wire[1:0] w_3x1; GF4PWR3 i_3x1(w_3x1, x1);
wire[3:0] w_t8; GF24MUL i_t8(w_t8, wiBx0, w_3x1);
wire[3:0] w_s1_7; GF24ADD i_s1_7(w_s1_7, w_t8, w_3x1);
wire[3:0] w_t9; GF24MUL i_t9(w_t9, w_2iBx0, w_3x1);
wire[3:0] w_s1_8; GF4ADD i_s1_8(w_s1_8, w_t9, w_s1_7);
GF4ADD i_s1_9(F1, w_s1_8, w_s1_6);
wire[3:0] wtB_t6; GF4MULB itB_t6(wtB_t6, w_t6);
wire[3:0] wtA_t5; GF4MULA itA_t5(wtA_t5, w_t5);
wire[3:0] w_s0_3; GF4ADD i_s0_3(w_s0_3, wtA_t5, wtB_t6);
wire[3:0] w_t4; GF4MUL i_t4(w_t4, wiBx0, x1);
wire[3:0] wtB_t4; GF4MULB itB_t4(wtB_t4, w_t4);
wire[3:0] wtAx1; GF4MULA itAx1(wtAx1, x1);
wire[3:0] w_s0_2; GF4ADD i_s0_2(w_s0_2, wtAx1, wtB_t4);
wire[3:0] w_s0_4; GF4ADD i_s0_4(w_s0_4, w_s0_2, w_s0_3);
wire[3:0] w_s0_0; GF24ADD i_s0_0(w_s0_0, w_2iBx0, w_3iBx0);
wire[3:0] wi1tAiBx0; GF4ADD1 ii1tAiBx0(wi1tAiBx0, wtAiBx0);
wire[3:0] w_s0_1; GF4ADD i_s0_1(w_s0_1, wi1tAiBx0, w_s0_0);
wire[3:0] w_s0_5; GF4ADD i_s0_5(w_s0_5, w_s0_1, w_s0_4);
wire[3:0] w_s0_6; GF4ADD i_s0_6(w_s0_6, w_t7, w_t8);
wire[3:0] wtA_t9; GF4MULA itA_t9(wtA_t9, w_t9);
wire[3:0] w_s0_7; GF4ADD i_s0_7(w_s0_7, wtA_t9, w_s0_6);
GF4ADD i_s0_8(F0, w_s0_7, w_s0_5);
endmodule

